<?php
error_reporting(E_ALL);
define('INCLUDED', TRUE);
define('MICROBLOG_VERSION', '1.1.5');

include "lib.php";
include "lang.php";
include "settings.php";
include "sess.php";
include "plugins.php";

load_plugins();

hook(MBE_HEADER_BEFORE);

header("Pragma: no-cache");

$_v = $_c = array();
foreach ($_GET as $k => $v)  $_v[$k] = $v;
foreach ($_POST as $k => $v) $_v[$k] = $v;
foreach ($_COOKIE as $k => $v) $_c[$k] = $v;

// Magic quotes
if (get_magic_quotes_gpc()) foreach($_v as $k => $v) $_v[$k] = stripslashes($v);

$_v['action'] = (isset($_v['action']) ? $_v['action'] : "");

if ($_v['action'] == "login")
{
	if (isset($_v['pass']) and $_v['pass'] == $_s['pass'])
	{
		hook(MBE_LOGIN_BEFORE);
		$sid = md5(uniqid(""));
		setcookie("sid", $sid, time() + 604800);
		$f = fopen("sess.php", "w+");
		fwrite($f, '<? $_s["sid"] = "'.$sid.'"; ?>');
		fclose($f);
		hook(MBE_LOGIN_AFTER);
		header("Location: ".$_SERVER['PHP_SELF']);
	}
	else
	{
		hook(MBE_LOGIN_FORM_SHOW_BEFORE);
		include $tpl['login_form'];
	}
	exit();
}
elseif ($_v['action'] == "logout")
{
	if (is_admin()) 
	{
		hook(MBE_LOGOUT_BEFORE);
		setcookie("sid", "");
	}
	header("Location: ".$_SERVER['PHP_SELF']);
}

include $tpl['header'];

include $tpl['left'];

switch($_v['action'])
{
case "comment":
if(isset($_v['p']) && strlen($_v['p']) == 10 && is_numeric($_v['p']) && file_exists("data/posts/".$_v['p']))
{
	$_v['nick'] = (@trim($_v['nick']) ? $_v['nick'] : "Anonymous");
	if (@trim($_v['text']))
	{
		$text = substr($_v['text'], 0, 4096);
		$nick = substr($_v['nick'], 0, 24);
		$f = array("<", ">", "\n", "\r", "");
		$text = str_replace($f, array("&lt;", "&gt;", "<br>", "", "&#166;"), $text);
		$nick = str_replace($f, "", $nick);

		$cmnt_date = time();

		$comment_allow = true;
		hook(MBE_COMMENT_ADD_BEFORE);
		if ($comment_allow) 
		{
			$fh = fopen("data/comments/".$_v['p'], "a+");
			flock($fh, LOCK_EX);
			fwrite($fh, $nick."".$cmnt_date."".$text."\n");
			flock($fh, LOCK_UN);
			fclose($fh);
		
			hook(MBE_COMMENT_ADD_AFTER);
		
			print $_l['cmnt_add'];
		}
		redirect(generate_link($_v['p']));
	}
}
break;

case "add_post":
	if (!is_admin()) exit();
	
	include "spaw2/spaw.inc.php";
 $editor = new SpawEditor("text");
	
	if (!isset($_v['title']) || !isset($_v['text']))
	{
		$post['title'] = $post['text'] = $p = "";
		hook(MBE_POST_FORM_SHOW_BEFORE);
		include $tpl['post_form'];
		hook(MBE_POST_FORM_SHOW_AFTER);
	}
	else
	{
		$p = time();
		$post_title = $_POST['title'];
		$post_html = $_POST['text'];
		//echo "$post_title $post_html";
		//die('1');
		
		hook(MBE_POST_ADD_BEFORE);
		
		$f = fopen("data/posts/".$p, "w+");
		fwrite($f, $post_title."\n".$post_html);
		fclose($f);
		$f = fopen("data/comments/".$p, "w+");
		fclose($f);
		
		hook(MBE_POST_ADD_AFTER);
		
		@chmod("data/posts/".$p, 0777);
		@chmod("data/comments/".$p, 0777);
		redirect($_SERVER['PHP_SELF']);
	}
break;

case "del_post":
	if (!is_admin() or !isset($_v['p'])) exit();
	
	hook(MBE_POST_DELETE_BEFORE);
	
	@unlink("data/posts/".$_v['p']);
	@unlink("data/comments/".$_v['p']);
	
	hook(MBE_POST_DELETE_AFTER);
	
	// TODO:   ,   /index.php  / 
	//           
	redirect($_SERVER['PHP_SELF']);
	break;

case "del_comment":
	if (!is_admin() or !isset($_v['p']) or !isset($_v['c'])) exit();
	$cmnts = file("data/comments/".$_v['p']);

	hook(MBE_COMMENT_DELETE_BEFORE);
	
	unset($cmnts[$_v['c']]);
	$f = fopen("data/comments/".$_v['p'], "w+");
	flock($f, LOCK_EX);
	fwrite($f, implode("", $cmnts));
	flock($f, LOCK_UN);
	fclose($f);
	hook(MBE_COMMENT_DELETE_AFTER);
	
	redirect(generate_link($_v['p']));
break;

case "edit_post":

	if (!is_admin() or !isset($_v['p'])) exit();
	
	if (!isset($_v['title']) || !isset($_v['text']) || !isset($_v['p']))
	{
		$post = post_info($_v['p']);
		
		include "spaw2/spaw.inc.php";
    $editor = new SpawEditor("text",$post['text']);
		
		$post['title'] = str_replace('"', '&quot;', $post['title']);
		hook(MBE_POST_FORM_SHOW_BEFORE);
		include $tpl['post_form'];
		hook(MBE_POST_FORM_SHOW_AFTER);
	}
	else
	{
		hook(MBE_POST_EDIT_BEFORE);
		
		$f = fopen("data/posts/".$_v['p'], "w+");
		flock($f, LOCK_EX);
		fwrite($f, $_v['title']."\n".$_v['text']);
		flock($f, LOCK_UN);
		fclose($f);
		
		hook(MBE_POST_EDIT_AFTER);
		
		redirect($_SERVER['PHP_SELF']);
	}
break;

default:

$time_offset = $_s['time_offset'] * 3600;
$time_now = time() + $time_offset;

if (isset($_v['p']) && strlen($_v['p']) == 10 && is_numeric($_v['p']))
{
	$post = post_info($_v['p']);
	$post['text'] = str_replace(array("\r", "\n"), array("", "\r"), $post['text']);
	$post['text'] = str_replace("\r", "\n", $post['text']);

	$post['text'] = str_replace("\n", "<br>\n", $post['text']);
	$post['edit'] = $post['del'] = "";

	$post_id = $post['id'] + $time_offset;

	$date = date("d", $post_id)." ".$_m[date("n", $post_id)];
	include $tpl['day'];

	hook(MBE_POST_SHOW_BEFORE);
	include $tpl['post'];

	// Comments
	print "<a name=comment>";
	$comment = file("data/comments/".$_v['p']);
	for ($i=0; $i < $post['c_count']; $i++)
	{
		$cmnt['del'] = "";
		if (is_admin()) $cmnt['del'] = '[<a href="?action=del_comment&c='.$i.'&p='.$_v['p'].'">'.$_l['del'].'</a>]';

		$c = explode("", $comment[$i]);
		$cmnt['nick'] = $c[0];
		$cmnt['date'] = date($_s['comment_dateformat'], $c[1]+$time_offset); // date time
		$cmnt['text'] = $c[2];

		hook(MBE_COMMENT_SHOW_BEFORE);
		include $tpl['comment'];
		
		unset($c);
	}
	include $tpl['comment_form'];
}
else
{
	$posts_get_standart = 1;	// 1 - , 0 -      
	$posts = array();
	hook(MBE_POSTS_GET_BEFORE);
	if ($posts_get_standart == 1)
	{
		$d = dir("data/posts");
		while (false !== ($entry = $d->read()))
			if (is_numeric($entry)) $posts[] = $entry;
		$d->close();
	}
	hook(MBE_POSTS_GET_AFTER);
	
	rsort($posts);
	$pages = sizeof($posts) / $_s['ppp'];
	$skip = (isset($_v['skip']) && is_numeric($_v['skip']) ? $_v['skip'] : 0);
	
	//   ,    
	if ($posts_get_standart == 1)
	{
		if (sizeof($posts) > $_s['ppp']) $posts = array_slice($posts, $skip, $_s['ppp']);
	}
	else 
	{
		//     ,      
		$pages = 0;
	}

	$last_day = 0;

	for ($i = 0; $i< sizeof($posts); $i++)
	{
		$post = post_info($posts[$i]);
		$post_id = $post['id'] + $time_offset;
		if ($last_day != date("d", $post_id) )
		{
			$last_day = date("d", $post_id);
			$month = $_m[date("n", $post_id)];
			$date = $last_day." ".$month;
			include $tpl['day'];
		}

		$post['text'] = preg_replace_callback("#\<pre\>(.*)\<\/pre\>#is", "pre", $post['text']);
		$post['text'] = str_replace("\n", "<br>\n", $post['text']);
		$post['text'] = str_replace("\r", "\n", $post['text']);

		if(preg_match("#(.*)<cut text=\"(.*)\">#sU", $post['text'], $cut))
		{
			$post['text'] = $cut[1].'<a href="'.generate_link($post['id']).'">'.$cut[2].'</a>';
		}

		$post['edit'] = $post['del'] = "";
		if (is_admin())
		{
			$post['edit'] = '<small>[<a href="?action=edit_post&p='.$posts[$i].'">'.$_l['ed'].'</a>]</small>';
			$post['del']  = '<small>[<a href="?action=del_post&p='.$posts[$i].'">'.$_l['del'].'</a>]</small>';
		}

		hook(MBE_POST_SHOW_BEFORE);
		include $tpl['post'];
	}

	if ($pages > 1)
	{
		$pages_link = "<center><a href=".$_SERVER['PHP_SELF'].">1</a> ";
		$j=1;
		while($j <= $pages)
		{
			$pn = $j + 1;
			$pages_link .= "<a href=?skip=".$j*$_s['ppp'].">".$pn."</a> ";
			$j++;
		}
		print $pages_link."</center>";
	}
}
break;
}
include $tpl['right'];

hook(MBE_FOOTHER_BEFORE);
include $tpl['foother'];
hook(MBE_FOOTHER_AFTER);


//
//print "<pre>";
//print_r($HOOKS);
//print "</pre>";

?>