<?php

// Get containers
$d = dir('data/blocks/');
while (false !== ($entry = $d->read()))
{
    if ($entry != '.' && $entry != '..' && is_dir('data/blocks/'.$entry))
    {
    	$containers[] = $entry;
    }
}
$d->close();

switch ($_v['action']) {
	case 'list':
		$d = dir('data/blocks/');
		while (false !== ($entry = $d->read())) {
			if ($entry != '.' && $entry != '..')
			{
				if (is_dir('data/blocks/'.$entry))
				{
					print '<table border=0 colspan=><tr> <td><b>'.$entry.'</b></td> </tr>';

					$bd = dir('data/blocks/'.$entry);
					$blocks_list = array();
					while (false !== ($block = $bd->read()))
					{
						if ($block != '.' && $block != '..')
						{
							$blocks_list[] = $block;
						}
					}
					asort($blocks_list);
					foreach ($blocks_list as $block) 
					{
						print '<tr> <td>&nbsp;&nbsp;&nbsp;&nbsp;'.$block.'</td> <td><a href="?plugin=blocks&action=edit&container='.$entry.'&block='.$block.'">Edit</a></td> <td><a href="?plugin=blocks&action=del&container='.$entry.'&block='.$block.'" onClick="return confirm(\'Delete '.$block.' ?\')">Del</a></td> </tr>';
					}
					$blocks_list = '';
					print '</table>';
				}
			}
		}
		$d->close();

		break;

	case 'edit':
		if (!isset($_v['block_content']))
		{
			print '<form action="'.$PHP_SELF.'" method=post>';
			print '<input type=hidden name=plugin value="'.$_v['plugin'].'">';
			print '<input type=hidden name=action value="'.$_v['action'].'">';
			print '<input type=hidden name=block value="'.$_v['block'].'">';
			print '<input type=hidden name=old_container value="'.$_v['container'].'">';
			print '<input type=text name=file value="'.$_v['block'].'">';
			print '<select name="container">';
			for ($i = 0; $i < sizeof($containers); $i++)
			{
				print '<option value="'.$containers[$i].'"'.($_v['container'] == $containers[$i] ? 'selected' : '').'>'.$containers[$i].'</option>';
			}
			print '</select><br>';
			print '<textarea name="block_content" rows=20 cols=80>'.htmlspecialchars(file_get_contents('data/blocks/'.$_v['container'].'/'.$_v['block'])).'</textarea><br>';
			print '<input type=submit></form>';
		}
		else
		{
			// if block name or container changed then delete old file and write to new
			if (($_v['block'] != $_v['file']) || ($_v['old_container'] != $_v['container']) )
			{
				unlink('data/blocks/'.$_v['old_container'].'/'.$_v['block']);
				$_v['block'] = $_v['file'];
			}

			$f = fopen('data/blocks/'.$_v['container'].'/'.$_v['block'], 'w+');
			fwrite($f, $_v['block_content']);
			fclose($f);
		}
		break;

	case 'del':
		if (file_exists('data/blocks/'.$_v['container'].'/'.$_v['block']))
		{
			if (unlink('data/blocks/'.$_v['container'].'/'.$_v['block']))
			{
				redirect('?plugin=blocks&action=list');
			}
		}
		break;

	case 'new_block':
		if (!isset($_v['block_content']))
		{
			print '<form action="'.$PHP_SELF.'" method=post>';
			print '<input type=hidden name=plugin value="'.$_v['plugin'].'">';
			print '<input type=hidden name=action value="'.$_v['action'].'">';
			print '<input type=text name="file">';
			print '<select name="container">';
			for ($i = 0; $i < sizeof($containers); $i++)
			{
				print '<option value="'.$containers[$i].'">'.$containers[$i].'</option>';
			}
			print '</select><br>';
			print '<textarea name="block_content" rows=20 cols=80></textarea><br>';
			print '<input type=submit></form>';
		}
		else
		{
			$f = fopen('data/blocks/'.$_v['container'].'/'.$_v['file'], 'w+');
			fwrite($f, $_v['block_content']);
			fclose($f);
			
			redirect('?plugin=blocks&action=list');
		}
		break;

}

?>
