<?php
define('INCLUDED', TRUE);

include "lib.php";
include "lang.php";
include "settings.php";
include "sess.php";
include "plugins.php";

header("Pragma: no-cache");

$_v = $_c = array();
foreach ($_GET as $k => $v)  $_v[$k] = $v;
foreach ($_POST as $k => $v) $_v[$k] = $v;
foreach ($_COOKIE as $k => $v) $_c[$k] = $v;

// Magic quotes
if (get_magic_quotes_gpc()) foreach($_v as $k => $v) $_v[$k] = stripslashes($v);

if (is_admin() == false) exit();

/*
function generate_actions_list($actions)
{
	global $_v;
	foreach ($actions as $action => $name) {
		if (@$_v['action'] == $action)
			$action_class = 'action_selected';
		else
			$action_class = 'action';
		print '<span class="'.$action_class.'"><a href="?plugin='.$_v['plugin'].'&action='.$action.'">'.$name.'</a></span> ';
	}
	print '<br><br>';
}
*/


// Switch ON/OFF plugins
if (isset($_v['on']) || isset($_v['off']))
{
	// switch ON the plugin
	if (isset($_v['on']) && !in_array($_v['on'], $_s['plugins']))
	{
		$_s['plugins'][] = $_v['on'];

	}
	
	// switch OFF the plugin
	else if (isset($_v['off']) && in_array($_v['off'], $_s['plugins']))
	{
		unset($_s['plugins'][ array_search($_v['off'], $_s['plugins']) ]);
	}

	$f = fopen('data/plugins', 'w');
	fwrite($f, serialize($_s['plugins']));
	fclose($f);
}


include $tpl['header'];
?>
<style type="text/css">
body, table        {font: 11px 'Verdana';}
.plugin a          {color: #000;}
.plugin_selected a {color: #f60;}
.action a          {background: #fff; color: #000; }
.action_selected a {color: #f60;}
.left_menu         {background: #fff; color: #000;}
.top_bar           {background: #f60; color: #fff; border-width: 1px; border-color: #ccc; border-style: solid;}
.top_bar a         {color: #fff;}
</style>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1251">
<h2>Admin panel</h2>
<table border="0" height="500">
<tr>
<!-- Plugins list-->
<td align="left" valign="top" class="left_menu">
<?php

// List of plugins
foreach ($_s['plugins'] as $_plugin) {
	if (file_exists('plugins/'.$_plugin.'/'.$_plugin.'_info.php'))
	{
		unset($actions);
		include 'plugins/'.$_plugin.'/'.$_plugin.'_info.php';

		if (@$_v['plugin'] == $_plugin)
			$plugin_class = 'plugin_selected';
		else
			$plugin_class = 'plugin';
		print '<span class="'.$plugin_class.'"><a href="?plugin='.$_plugin.'" title="'.$plugin_description.'"><b>'.$plugin_name.'</b></a></span><br>';
		if (isset($actions))
		{
			foreach($actions as $action_link => $action_title)
			{
				$action_class = (@$_v['action'] == $action_link && @$_v['plugin'] == $_plugin ? 'action_selected' : 'action');

				print '&nbsp;&nbsp;&nbsp;&nbsp;<span class="'.$action_class.'"><a href="?plugin='.$_plugin.'&action='.$action_link.'">'.$action_title.'</a></span><br>';
			}
		}
	}
}

?>

</td>

<!-- Plugin functions -->
<td align="left" valign="top">
<?php
if (isset($_v['plugin']))
{
	if (file_exists('plugins/'.$_v['plugin'].'/'.$_v['plugin'].'_info.php'))
	{
		$actions = false;
		
		include('plugins/'.$_v['plugin'].'/'.$_v['plugin'].'_info.php');

		if (!isset($_v['action']))
		{
			print '<div class="top_bar"><a href="admin.php">Plugins</a> &rarr; <a href="admin.php?plugin='.$_v['plugin'].'">'.$plugin_name.'</a></div><br>';
			print '<font size="+1"> '.$plugin_name."</font> <font size=1>v".$plugin_version."</font><br>";
			print 'Author: <b>'.$plugin_author.'</b><br><br>';
			print $plugin_description."<br><br>";
			
			if ($actions)
			{
				print "Actions:<br>";
				foreach($actions as $action_link => $action_title)
				{
					print '&rarr; <a href="?plugin='.$_v['plugin'].'&action='.$action_link.'">'.$action_title.'</a><br>';
				}
			}

		}
		else
		{
			print '<span class="top_bar"><a href="admin.php">Plugins</a> &rarr; <a href="admin.php?plugin='.$_v['plugin'].'">'.$plugin_name.'</a> &rarr; <a href="admin.php?plugin='.$_v['plugin'].'&action='.$_v['action'].'">'.(isset($actions[$_v['action']]) ? $actions[$_v['action']] : $_v['action']).'</a></span><br>';
			include('plugins/'.$_v['plugin'].'/'.$_v['plugin'].'_admin.php');	
		}
	}
}
else	// list of ALL plugins
{
	print '<table border=0><tr style="background: #eee;"> <td>Plugin</td> <td>Description</td> <td>Author</td> <td>Version</td> <td>State</td> </tr>';

	$dir = opendir('plugins');
	while (false !== ($plugin_file = readdir($dir))) 
	{ 
		if (file_exists('plugins/'.$plugin_file.'/'.$plugin_file.'_info.php'))
		{
			include 'plugins/'.$plugin_file.'/'.$plugin_file.'_info.php';
			$plugin_state = ( in_array($plugin_file, $_s['plugins']) ? '<a href="admin.php?off='.$plugin_file.'"><font color="green">On</font></a>' : '<a href="admin.php?on='.$plugin_file.'"><font color="red">Off</font></a>');   
			print '<tr> <td>'.$plugin_name.'</td> <td>'.$plugin_description.'</td> <td>'.$plugin_author.'</td> <td>'.$plugin_version.'</td> <td>'.$plugin_state.'</td> ';
		}
	}
	closedir($dir);
	print '</fieldset>';
}
?>

</td>
</tr>
</table>