<?php
if (!defined('INCLUDED')) exit();

// Hooks
DEFINE('MBE_HEADER_BEFORE',          10);	//  
DEFINE('MBE_FOOTHER_BEFORE',         20);	//   
DEFINE('MBE_FOOTHER_AFTER',          30);	//   
DEFINE('MBE_LOGIN_BEFORE',           40);	//  
DEFINE('MBE_LOGIN_AFTER',            50);	//  
DEFINE('MBE_LOGIN_FORM_SHOW_BEFORE', 60);	//     
DEFINE('MBE_LOGOUT_BEFORE',          70);	//  
DEFINE('MBE_POST_FORM_SHOW_BEFORE',  80);	//    
DEFINE('MBE_POST_FORM_SHOW_AFTER',   90);	//    
DEFINE('MBE_POST_ADD_BEFORE',        100);	//   
DEFINE('MBE_POST_ADD_AFTER',         110);	//   
DEFINE('MBE_POST_SHOW_BEFORE',       120);	//   
DEFINE('MBE_POST_DELETE_BEFORE',     130);	//   
DEFINE('MBE_POST_DELETE_AFTER',      140);	//   
DEFINE('MBE_POST_EDIT_BEFORE',       150);	//   
DEFINE('MBE_POST_EDIT_AFTER',        160);	//   
DEFINE('MBE_COMMENT_ADD_BEFORE',     170);	//   
DEFINE('MBE_COMMENT_ADD_AFTER',      180);	//   
DEFINE('MBE_COMMENT_DELETE_BEFORE',  190);	//   
DEFINE('MBE_COMMENT_DELETE_AFTER',   200);	//   
DEFINE('MBE_COMMENT_SHOW_BEFORE',    210);	//   
DEFINE('MBE_POSTS_GET_BEFORE',       220);	//    
DEFINE('MBE_POSTS_GET_AFTER',        230);	//   

$_s['plugins'] = unserialize(file_get_contents('data/plugins'));
$HOOKS = array();

function register_hook($hook_name, $function_name) {
	global $HOOKS;
	if ($hook_name and function_exists($function_name)) {
		$HOOKS[$hook_name][] = $function_name;
	}
}

function hook($hook_name) {
	global $HOOKS, $_s;

	if (!$_s['plugins_enable']) {
		return 0;
	}

	if (@sizeof($HOOKS[$hook_name])) {
		foreach ($HOOKS[$hook_name] as $func) {
			#print "<b>".$func."</b><br>";
			$func();
		}
	}
}

function load_plugins() {
	global $_s;

	if (!$_s['plugins_enable']) {
		return 0;
	}

	foreach ($_s['plugins'] as $plugin) {
		include_once 'plugins/'.$plugin.'/'.$plugin.'_funcs.php';
		include_once 'plugins/'.$plugin.'/'.$plugin.'_info.php';
	}
}
?>
